// Maz Uber-Newbie Tutorial V.1 - 10/4/2003 // <- (Comment's there)

/*
So, where to start?
 I personally would start by loading up a new .dm file giving
 it a title and date, this way when you want to brag about how
 long you have been working on something you can be pretty
 accurate. It may also be a good idea to create another .dm file
 called notes.dm, this is simply for ideas and other inspiration's
 you may get mid-project.

What now?
 So you want to start making something, let not rush, one last
 pause. What do *you* want to do? an RPG, a board game, a puzzle
 game, a utility for generating the average geekyness of a BYONDer
 anything, just write that down in your notes.dm and dont forget its
 there.

First thing's first.
 This is usually the hardest thing to figure, where to start? It's
 quite a daunting task to see page's of white mocking you. So lets
 start covering it in colour.

we can start with something that nearly everygame will need, a
hearty welcome!

*/ // <- (long comments there)

mob
	Login()
		src << "Hey [src]"
		..()

/*
So what is this?
 A mob is what the player who join's is given, for example if I were
  to say login I would be a /mob/maz, then we go on to the next line
  and indent it by one.
 Login() is a pre-made procedure, e.g. every mob has it. It's called
  when a player enter's the mob.
 In BYOND there are 2 easy way's to get to the player, src and usr.
  I will stress this now. USR is EVIL! Please avoid it at all cost's
  unless you know what you are doing. src refer's to the source of
  the procedure (This get's easier, I assure you.) the source of this
  procedure is... the mob of the player.
 << means give something an output, so what we are doing is making it
  output "Hey [src]"
 [src] is a variable, that why its in square bracket's. I this instance
  it means the name of the source, which for me is Maz because thats
  my name.

So it says hi to you, big deal.
  good point, lets try change it to say Hi to the world.
  world means everything, so if you send it to the world you guaranteed
  to get you message across. However, I will not show you how to do
  something that you would want to do, add speech.
*/

	verb
		Say(Text_entered as text)
			world << "[src] says [Text_entered]"

/*
Let's take a thought. Again.
 Where's the mob?
  The mob is already implied via indentation. A joy of this sort of
  programming (object-oriented.) is that you only need to do it once.
 verb's are commands that are given to the player, if you ran the
  tutorial you would have a say verb, if you clicked it would ask for
  some text, this is then outputted to the players in the world (game)
*/

// Enough with the mob's.

/*
Unless you are planning on a purely text MUD, which can still use the
 same system as this, you will want to make turfs.

A turf is a tile that you place on a map, so before you have turfs you
need... A map.
 So, goto File > New and change the Type to Map file (.dmp) give it a
 name and it will go into the colomn to the left. I choose to not make
 one to force you to read this - bwahahah.
Now to turfs.
 We start with a simple grass turf
*/

turf
	grass
		icon = 'turf.dmi'
		icon_state = "grass"

/*
Now when you double click on your map it will load into the map editor
 in the left colomn is every object in your game, mob's, turfs, obj's
  and maybe even an area.
 if you click on one it will come into the center and you can add it to
  your map, so click on the + next to turf, then click on grass.
  now use fill to cover your map with grass.
Lets make a maze out of this map.
 We will now make another type of turf. A wall.
*/

	wall
		icon = 'turf.dmi'
		icon_state = "wall"
		density = 1

/*
Wait, have I forgotten something?
 What's an icon? Whats an icon_state?
  Well an icon is a .dmi file, and an icon_state is the name of the
  image in the file.
 Density, quite obviously explains itself. but this wall to me has
 one problem. You can see through it. So, remove the comments from
 the next line to make it opaque.
*/

//		opacity = 1

/*
There a much more realistic wall, if you were making a window then it
would be better left with out opacity.
*/

// Objects. Pickupables and other random things.

/*
An object is a mob that players cannot be, pretty simply put. They have
less variables and therefore, better to use them instead.
*/

obj
	crown
		icon = 'objects.dmi'
		icon_state = "crown"

/*
 So its a crown, but it does nothing. Whats its point?
  Why not make it so you can pick it up and drop it?
*/

		verb
			get()
				set src in oview(1)
				src.Move(usr)

/*
Wait, am I being hypocritical here?
 Yes, and no. You should avoid using usr, yet there are times when it
  is safe, for simplicity I used it here.
 So whats set src in oview(1)?
  it is literally what it says, set the verb to a source in the oview
   in 1 tile. I means that once the object is in the player then they
   cannot see the verb. Lets add a drop verb.
*/

			drop()
				set src in usr
				src.Move(usr.loc)

/*
We are now moving it out of the player and onto the floor below them.
 the set src in usr makes it only come up if the object is in the
 players contents. Again, take special notice of the usr.

I think this should be enough to ask you to do one more thing to finish
 off the tutorial, you need to create a new icon file and draw something
 give that an icon_state (double click on the white space under the icon
 to name it) and then set the mob's icon.
*/

mob



// Maz